;Programm fr Rund-Lauflicht 5-Kanal (programmgesteuert)
;Anschlsse PB0 - PB4 fr 5 LEDs
;Device AT90S2313, Taktfrequenz 4 MHz
;-------------------------------------------------------------
.include "2313def.inc"
.def temp  = r16
.def temp2 = r17
.def w1    = r18
.def w2    = r19
.def w3    = r20
;-------------------------------------------------------------

ldi temp, RAMEND                  ;Stackpointer setzen
out SPL, temp
ldi temp, 0b00011111              ;PB Ausgnge 0, 1, 2, 3, 4
out DDRB, temp                    ;   Eingnge MOSI MISO SCK (5-7)
ldi temp, 0b00000000              ;Ausgnge auf 0, Pullups aus
out PORTB, temp

start:
rcall ll1                         ;Lauflicht 1
rcall ll2                         ;Lauflicht 2
rcall ll3                         ;Lauflicht 3
rcall ll4                         ;Lauflicht 4
rcall on                          ;alles an
rcall blink                       ;alles blinkt
rcall innenaussen                 ;innen/aussen-Effekt
rjmp start                        ;von vorne

ll1:                              ;Lauflicht 1
ldi temp2, 250                    ;256-250 = 6 Durchlufe
ll1start:                         ;Durchlauf start
ldi temp, 0b00000001
out PORTB, temp
rcall warten                      ;(100 mS warten)
rcall warten
ldi temp, 0b00000010
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00000100
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00001000
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00010000
out PORTB, temp
rcall warten
rcall warten
inc temp2                         ;nchster Durchlauf
brne ll1start                     ;wenn kein berlauf (255 --> 0)
ret

ll2:
ldi temp2, 250
ll2start:
ldi temp, 0b00010001
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00000011
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00000110
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00001100
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00011000
out PORTB, temp
rcall warten
rcall warten
inc temp2
brne ll2start
ret

ll3:
ldi temp2, 250
ll3start:
ldi temp, 0b00011001
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00010011
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00000111
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00001110
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00011100
out PORTB, temp
rcall warten
rcall warten
inc temp2
brne ll3start
ret

ll4:
ldi temp2, 250
ll4start:
ldi temp, 0b00011101
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00011011
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00010111
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00001111
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00011110
out PORTB, temp
rcall warten
rcall warten
inc temp2
brne ll4start
ret

on:
ldi temp, 0b00011111
out PORTB, temp
rcall warten
rcall warten
rcall warten
rcall warten
rcall warten
ret

blink:
ldi temp2, 250
blinkstart:
ldi temp, 0b00011111
out PORTB, temp
rcall warten
rcall warten
rcall warten
ldi temp, 0b00000000
out PORTB, temp
rcall warten
rcall warten
rcall warten
inc temp2
brne blinkstart
ret

innenaussen:
ldi temp2, 250
innenaussenstart:
ldi temp, 0b00000000
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00000100
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00001110
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00011111
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00011011
out PORTB, temp
rcall warten
rcall warten
ldi temp, 0b00010001
out PORTB, temp
rcall warten
rcall warten
inc temp2
brne innenaussenstart
ret

warten:                           ;Warteschleife 50 mS
ldi w1, 0
ldi w2, 0
schleife:
inc w1
brne schleife
inc w2
brne schleife
ret
